<template>
    <el-card class="tjm_card_style_custom">
        <div class="tjm_card_title">查询表格</div>
        <div class="tjm_card_select">
            <el-form class="tjm_card_select_left" :model="params" inline label-width="80px" label-position="left">
                <!-- <el-form-item label="所属部门">
		            <el-tree-select v-model="deptQuery.modelValue" :data="deptQuery.data" :props="deptQuery.props" check-strictly filterable clearable placeholder="请选择所属部门" @node-click="nodeClick"></el-tree-select>
                </el-form-item> -->
                <el-form-item label="政策编号">
                    <el-input v-model="params.businessNo" clearable placeholder="请输入政策编号"></el-input>
                </el-form-item>
                <el-form-item label="政策名称">
                    <el-input v-model="params.name" clearable placeholder="请输入政策名称"></el-input>
                </el-form-item>
                <el-form-item label="政策等级">
                    <el-select v-model="params.zcLevel" clearable placeholder="请选择政策等级">
                        <el-option v-for="item in levelDic" :key="item" :label="item" :value="item"></el-option>
                    </el-select>
                </el-form-item>
                <el-form-item label="政策类别">
                    <el-select v-model="params.zcType" clearable placeholder="请选择政策类别">
                        <el-option v-for="item in typeDic" :key="item" :label="item" :value="item"></el-option>
                    </el-select>
                </el-form-item>
                <el-form-item label="状态">
                    <el-select v-model="params.status" clearable placeholder="请选择状态">
                        <el-option v-for="(label, key) in statusDic" :key="key" :label="label" :value="key"></el-option>
                    </el-select>
                </el-form-item>
                <el-form-item label="是否入库">
                    <el-select v-model="params.isInWh" clearable placeholder="请选择入库状态">
                        <el-option v-for="(label, key) in whetherDic" :key="key" :label="label" :value="key"></el-option>
                    </el-select>
                </el-form-item>
                <el-form-item label="入库类别">
                    <el-select v-model="params.inWhType" clearable placeholder="请选择入库类别">
                        <el-option v-for="item in storageTypeDic" :key="item" :label="item" :value="item"></el-option>
                    </el-select>
                </el-form-item>
                <el-form-item label="填报日期">
                    <el-date-picker v-model="createTime" type="daterange" value-format="YYYY-MM-DD" range-separator="-" start-placeholder="开始日期" end-placeholder="结束日期"></el-date-picker>
                </el-form-item>

                <el-form-item>
                    <el-button type="primary" icon="search" @click="reloadTable">搜索</el-button>
                    <el-button icon="refresh-right" @click="reset">重置</el-button>
                </el-form-item>
            </el-form>
        </div>
        <el-divider></el-divider>

        <div class="tjm_card_tools">
            <div class="tjm_card_tools_left">
                <el-button type="primary" icon="plus" @click="table_add">新增</el-button>
            </div>
            <div class="tjm_card_tools_right flex-row">
                <table-import url="policyShare" @importSuc="reloadTable"></table-import>
                <el-button class="export-btn" icon="download" @click="table_export">导出</el-button>
                <el-button icon="download" @click="download_temp">导入模版下载</el-button>
            </div>
        </div>
        <div class="tjm_card_table">
            <el-table v-loading="loading" row-key="id" header-cell-class-name="tjm_card_table_header" height="400" :data="tableData" border @row-click="(row, column) => !column.fixed && table_detail(row)">
                <el-table-column type="index" label="序号" width="55"></el-table-column>
                <template v-for="(item, index) in columns" :key="index">
                    <el-table-column :label="item.label" :prop="item.props" :width="item.width || 180" show-overflow-tooltip>
                        <template #default="scope">{{ columnFormat(scope.row, item.props) }}</template>
                    </el-table-column>
                </template>
                <el-table-column label="操作" fixed="right" width="280">
                    <template #default="scope">
                        <template v-if="scope.row.status == 'active' || scope.row.status == 'inactive'">
                            <template v-if="scope.row.status == 'active'">
                                <el-button type="primary" link icon="edit" @click.stop="table_edit(scope.row)">修改</el-button>
                                <el-button type="primary" link icon="upload" @click.stop="table_edit(scope.row)">上报</el-button>
                            </template>
                            <template v-if="scope.row.status == 'inactive'">
                                <el-button type="primary" link icon="tickets" @click.stop="table_edit(scope.row)">重新上报</el-button>
                                <el-button v-if="scope.row.processTaskId && scope.row.processInstanceId" type="primary" link @click.stop="table_process(scope.row)">
                                    <template #icon><tjm-icon-uis-process /></template>
                                    审批流程
                                </el-button>
                            </template>
                            <el-button type="primary" link icon="delete" @click.stop="table_del(scope.row)">删除</el-button>
                        </template>
                        <template v-if="scope.row.status == 'approve' || scope.row.status == 'done'">
                            <el-button type="primary" link icon="tickets" @click.stop="table_detail(scope.row)">详情</el-button>
                            <el-button v-if="scope.row.processTaskId && scope.row.processInstanceId" type="primary" link @click.stop="table_process(scope.row)">
                                <template #icon><tjm-icon-uis-process /></template>
                                审批流程
                            </el-button>
                        </template>
                        <el-button v-if="scope.row.status == 'approve' && scope.row.isWithdraw == 1" type="primary" link icon="refresh-right" @click.stop="table_withdraw(scope.row)">撤回</el-button>
                    </template>
                </el-table-column>
            </el-table>
        </div>
        <div class="tjm_card_pagination">
            <yh-pagination v-model:pageNo="params.page" v-model:pageSize="params.size" :total="total" @paginationChange="reloadTable"></yh-pagination>
        </div>
    </el-card>

    <policy-dialog v-if="dialog.update" ref="policyDialog" @success="reloadTable" @closed="closed"></policy-dialog>
    <policy-detail v-if="dialog.detail" ref="policyDetail" @closed="dialog.detail = false"></policy-detail>
    <policy-process-dialog v-if="dialog.process" ref="processDialog" @success="reloadTable" @closed="dialog.process = false"></policy-process-dialog>
    <yh-workflow v-if="dialog.workflow" ref="yhWorkflow" @closed="dialog.workflow = false"></yh-workflow>
</template>

<script>
import Folder from "@/api/folder";
import Temp from "@/api/system/template";
import { getMainList } from "@/api/system/depart";

import API from "@/api/policy/share";
import { useUserStore } from "@/store/user";
import { exportExcel } from "@/utils/exportExcel";
import { columns, levelDic, typeDic, storageTypeDic, whetherDic, statusDic } from "./main";

import tableImport from "@/components/Upload/tableImport.vue";
import yhPagination from "@/components/Pagination/index.vue";
import policyDetail from "@/views/manage/policyShare/dialog.vue";
import policyDialog from "./dialog.vue";
import policyProcessDialog from "@/views/toDo/share.vue";
import yhWorkflow from "@/components/Workflow/index.vue";

export default {
    components: {
        tableImport,
        yhPagination,
        yhWorkflow,
        policyDetail,
        policyDialog,
        policyProcessDialog
    },

    data() {
        return {
            columns, levelDic, typeDic, storageTypeDic, whetherDic, statusDic,

            deptQuery: {
                modelValue: null,
                data: [],
                props: { 
                    label: "name",
                    value: "id"
                },
                paramsFormat: {
                    0: "deptId",
                    1: "companyId"
                }
            },

            loading: false,
            createTime: [],
            params: {
                page: 1,
                size: 10,
                createId: useUserStore().userInfo.id,
                userDeptId: useUserStore().userInfo.deptId
            },

            total: 0,
            tableData: [],

            dialog: {
                update: false,
                detail: false,
                process: false,
                workflow: false
            }
        }
    },

    mounted() {
        this.getDeptTree();
        this.reloadTable();
    },

    methods: {
        columnFormat(row, props) {
            if (props == "createTime") return row[props].split(" ")[0];
            if (props == "status") return statusDic[row[props]] || "";
            if (props == "isInWh") return whetherDic[row[props]] || "";
            return row[props];
        },

        getDeptTree() {
            getMainList().then(res => {
                if (res.code === 200) this.deptQuery.data = res.data;
                else ElMessage.error(res.msg);
            });
        },

        reloadTable(mode = "add") {
            if (mode == "add") this.params.page = 1;
            this.params.beginCreateTime = this.createTime && this.createTime.length && this.createTime[0] + " 00:00:00" || null;
            this.params.endCreateTime = this.createTime && this.createTime.length && this.createTime[1] + " 23:59:59" || null;

            this.loading = true;
            API.get(this.params).then(res => {
                this.loading = false;
                if (res.code === 200) {
                    this.tableData = res.data.records;
                    this.total = res.data.total;
                } else ElMessage.error(res.msg);
            }).catch(() => this.loading = false);
        },

        reset() {
            this.createTime = [];
            this.params = {
                page: 1,
                size: 10,
                createId: useUserStore().userInfo.id,
                userDeptId: useUserStore().userInfo.deptId
            }
                
            this.reloadTable();
        },

        nodeClick({ deptType, id }) {
            for (const key in this.deptQuery.paramsFormat) {
                this.params[this.deptQuery.paramsFormat[key]] = null;
            }

            this.params[this.deptQuery.paramsFormat[deptType]] = id;
        },

        table_export() {
            const header = columns.map(c => c.label);
            const data = this.tableData.map(v => columns.map(c => c.props).map(j => this.columnFormat(v, j)));

            exportExcel(header, data, [], `${this.$route.name}.xlsx`);
        },

        download_temp() {
            Temp.get({ refType: "policy_share" }).then(res => {
                if (res.code === 200) {
                    if (!res.data.records[0]) ElMessage.warning("暂无模版，请联系管理员");
                    else {
                        const { templateName, templateUrl } = res.data.records[0];
                        Folder.download(templateUrl).then(res => {
                            const a = document.createElement("a");
                            const blob = new Blob([res.data], { type: "application/vnd.openxmlformats-officedocument.spreadsheetml.sheet" });
                            a.download = templateName;
                            a.href = URL.createObjectURL(blob);
                            a.click();
                        });
                    }
                }else ElMessage.error(res.msg);
            });
        },

        table_add() {
            this.dialog.update = true;
            nextTick(() => this.$refs.policyDialog.open());
        },

        table_edit(row) {
            if (row.status == "inactive") {
                this.dialog.process = true;
                nextTick(() => this.$refs.processDialog.open("resubmit").setData(row.id));
            }
            if (row.status == "active") {
                this.dialog.update = true;
                nextTick(() => this.$refs.policyDialog.open("edit").setData(row.id));
            }
        },

        table_detail(row) {
            this.dialog.detail = true;
            nextTick(() => this.$refs.policyDetail.open("detail").setData(row.id));
        },

        table_del(row) {
            ElMessageBox.confirm("是否确认删除?", "删除警告", {
                type: "warning",
                confirmButtonText: "确定",
                cancelButtonText: "取消"
            }).then(() => {
                API.del({ ids: row.id }).then(res => {
                    if (res.code == 200) {
                        ElMessage.success("操作成功");
                        this.reloadTable();
                    } else ElMessage.error(res.msg);
                });
            }).catch(() => ElMessage.success("已取消"));
        },

        table_withdraw(row) {
            ElMessageBox.confirm("是否确认撤回?", "提示", {
                type: "warning",
                confirmButtonText: "确定",
                cancelButtonText: "取消"
            }).then(() => {
                API.withdraw(row).then(res => {
                    if (res.code === 200) {
                        ElMessage.success("操作成功");
                        this.reloadTable();
                    } else ElMessage.error(res.msg);
                });
            }).catch(() => ElMessage.success("已取消"));
        },

        closed(e) {
            e && this.reloadTable();
            this.dialog.update = false;
        },

        table_process(row) {
            this.dialog.workflow = true;
            nextTick(() => this.$refs.yhWorkflow.getDetail(row));
        }
    }
}
</script>

<style lang="scss" scoped>
.export-btn {
  margin-left: 12px;
}
</style>